﻿using System;
using System.Collections.Generic;

namespace com.bodurov.SortEvolver.EvolutionEngine.Extensions
{
    public static class Ext_LinkedListOfT
    {
        public static IEnumerable<LinkedListNode<T>> GetNodes<T>(this LinkedList<T> list)
        {
            var node = list.First;

            while (node != null)
            {
                yield return node;
                node = node.Next;
            }
        }

        public static TState FoldNodes<T, TState>(this LinkedList<T> list, Action<LinkedListFoldingState<TState, T>> func, TState state)
        {
            var foldingState = new LinkedListFoldingState<TState, T>(state);
            var node = list.First;

            var i = 0;
            while (node != null)
            {
                foldingState.Node = node;
                foldingState.Index = i++;

                func(foldingState);

                state = foldingState.State;
                if (foldingState.Cancel)
                {
                    return state;
                }

                node = node.Next;
            }
            return state;
        }
    }
}
