﻿using System;
using System.Linq;

namespace com.bodurov.SortEvolver.Processor
{
    public class IntArraySortTester
    {

        public IntArrayHolder GenerateUnsorted()
        {
            IntArrayHolder state;
            do
            {
                var array = CreateArray(100);

                ShaffleArra(array);

                state = new IntArrayHolder(array);
            }
            while (this.Evaluate(state) == 1); // it's very unlikely but possible
            return state;
        }

        public IntArrayHolder GenerateSorted()
        {
            var array = CreateArray(100);

            return new IntArrayHolder(array);
        }

        private static int[] CreateArray(int numElements)
        {
            var array = new int[numElements];
            for (var i = 0; i < numElements; i++ ) array[i] = i;
            return array;
        }

        private static void ShaffleArra(int[] array)
        {
            var random = new CryptoRnd();

            for (var i = 0; i < array.Length; i++)
            {
                if (array[i] == i)
                {
                    Swap(array, i, random.Next(0, 100));
                }
            }
        }

        private static void Swap(int[] array, int index1, int index2)
        {
            if (index1 == index2) return;
            var temp = array[index1];
            array[index1] = array[index2];
            array[index2] = temp;
        }

        public double Evaluate(IntArrayHolder state)
        {
            var result = 0.0;
            for(var i = 1; i < state.Array.Length; i++)
            {
                if(state.Array[i - 1] < state.Array[1])
                {
                    result++;
                }
            }
            return result/state.Array.Length;
        }

        
    }
}


