﻿using System;

namespace com.bodurov.SortEvolver.Processor
{
    public class TopIntArraySorter : IIntArraySorter
    {
        public double AvgSuccess { get; internal set; }

        public TopIntArraySorter Parent { get; internal set; }

        public int Generation { get; internal set; }

        public IntArrayHolder Run(IntArrayHolder state)
        {
            return state;
        }


        #region Readability marked methods
        [Executer(Status.Read)]
        public static IntArrayPointer GetFirstElement(IntArrayHolder state)
        {
            return new IntArrayPointer(state.Array, 0);
        }

        [Executer(Status.Read)]
        public static IntArrayPointer GetLastElement(IntArrayHolder state)
        {
            return new IntArrayPointer(state.Array, state.Array.Length - 1);
        }

        [Executer(Status.Read)]
        public static IntArrayPointer GetNextElement(IntArrayHolder state, IntArrayPointer pointer)
        {
            return new IntArrayPointer(state.Array, pointer.Index + 1);
        }

        [Executer(Status.Read)]
        public static IntArrayPointer GetPreviousElement(IntArrayHolder state, IntArrayPointer pointer)
        {
            return new IntArrayPointer(state.Array, pointer.Index - 1);
        }

        [Executer(Status.Read)]
        public static bool IsActivePointer(IntArrayHolder state, IntArrayPointer pointer)
        {
            return !pointer.IsOutsidePointer;
        }

        [Executer(Status.Read)]
        public static bool IsLessThan(IntArrayHolder state, IntArrayPointer pointer1, IntArrayPointer pointer2)
        {
            if (pointer1.IsOutsidePointer || pointer2.IsOutsidePointer) return false;
            return pointer1.Valus < pointer2.Valus;
        }

        [Executer(Status.Read)]
        public static bool IsGreaterThan(IntArrayHolder state, IntArrayPointer pointer1, IntArrayPointer pointer2)
        {
            if (pointer1.IsOutsidePointer || pointer2.IsOutsidePointer) return false;
            return pointer1.Valus > pointer2.Valus;
        }

        [Executer(Status.Write)]
        public static void Swap(IntArrayHolder state, IntArrayPointer pointer1, IntArrayPointer pointer2)
        {
            if (pointer1.IsOutsidePointer || pointer2.IsOutsidePointer) return;
            if (pointer1.Index == pointer2.Index) return;
            var p1Value = pointer1.Valus;
            pointer1.Array[pointer1.Index] = pointer2.Valus;
            pointer2.Array[pointer2.Index] = p1Value;
        }
        #endregion

    }
}
